'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _superficial = require('superficial');

var _superficial2 = _interopRequireDefault(_superficial);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function Breakpoint(_ref, looks) {
  var breakpoint = _ref.breakpoint,
      min = _ref.min,
      max = _ref.max;

  var style = {
    left: (breakpoint - min) / (max - min) * 100 + '%'
  };
  return _react2.default.createElement('div', { title: breakpoint, looks: looks.main, style: style });
}

Breakpoint.looks = {
  main: {
    position: 'absolute',
    top: '3px',
    height: 6,
    width: 6,
    background: 'black',
    borderRadius: 6
  }
};

var numOrString = _react2.default.PropTypes.oneOfType([_react2.default.PropTypes.string, _react2.default.PropTypes.number]);
Breakpoint.propTypes = {
  breakpoint: numOrString,
  min: numOrString,
  max: numOrString
};

exports.default = (0, _superficial2.default)(Breakpoint);