'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _superficial = require('superficial');

var _superficial2 = _interopRequireDefault(_superficial);

var _LookBar = require('./LookBar');

var _LookBar2 = _interopRequireDefault(_LookBar);

var _StyledInput = require('./StyledInput');

var _StyledInput2 = _interopRequireDefault(_StyledInput);

var _constants = require('../constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var dasherize = function dasherize(word) {
  return word.replace(/([a-z])([A-Z])/g, '$1-$2').toLowerCase();
};

var LookRule = function (_React$Component) {
  _inherits(LookRule, _React$Component);

  function LookRule() {
    var _ref;

    _classCallCheck(this, LookRule);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    var _this = _possibleConstructorReturn(this, (_ref = LookRule.__proto__ || Object.getPrototypeOf(LookRule)).call.apply(_ref, [this].concat(args)));

    _this.handleValueClick = _this.handleValueClick.bind(_this);
    _this.handlePropClick = _this.handlePropClick.bind(_this);
    _this.handleValueChange = _this.handleValueChange.bind(_this);
    _this.handlePropChange = _this.handlePropChange.bind(_this);
    _this.state = { edit: false };
    return _this;
  }

  _createClass(LookRule, [{
    key: 'handlePropClick',
    value: function handlePropClick() {
      this.setState({ edit: 'prop' });
    }
  }, {
    key: 'handleValueClick',
    value: function handleValueClick() {
      this.setState({ edit: 'value' });
    }
  }, {
    key: 'handlePropChange',
    value: function handlePropChange(value, didChange) {
      if (didChange) this.props.onChange(this.props.prop, { to: value });
      this.setState({ edit: false });
    }
  }, {
    key: 'handleValueChange',
    value: function handleValueChange(value, didChange) {
      if (didChange) this.props.onChange(this.props.prop, value);
      this.setState({ edit: false });
    }
  }, {
    key: 'renderProp',
    value: function renderProp() {
      if (this.state.edit === 'prop') {
        return _react2.default.createElement(_StyledInput2.default, {
          defaultValue: dasherize(this.props.prop),
          onChange: this.handlePropChange
        });
      }
      return dasherize(this.props.prop);
    }
  }, {
    key: 'renderValue',
    value: function renderValue() {
      var _props = this.props,
          prop = _props.prop,
          value = _props.value,
          min = _props.min,
          max = _props.max,
          width = _props.width;

      if (this.state.edit === 'value') {
        return _react2.default.createElement(_StyledInput2.default, {
          defaultValue: value,
          onChange: this.handleValueChange
        });
      }
      if ((typeof value === 'undefined' ? 'undefined' : _typeof(value)) !== 'object') return value;
      return _react2.default.createElement(_LookBar2.default, { prop: prop, value: value, min: min, max: max, width: width });
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        'tr',
        null,
        _react2.default.createElement(
          'td',
          { looks: this.looks.prop },
          _react2.default.createElement(
            'button',
            { looks: _constants.BUTTON_LOOK, onClick: this.handlePropClick },
            this.renderProp()
          )
        ),
        _react2.default.createElement(
          'td',
          null,
          _react2.default.createElement(
            'button',
            {
              looks: [_constants.BUTTON_LOOK, this.looks.value],
              onClick: this.handleValueClick
            },
            this.renderValue()
          )
        )
      );
    }
  }]);

  return LookRule;
}(_react2.default.Component);

LookRule.looks = {
  value: { width: '100%', color: '#222' }
};

LookRule.propTypes = {
  prop: _react2.default.PropTypes.string.isRequired,
  onChange: _react2.default.PropTypes.func.isRequired,
  value: _react2.default.PropTypes.any,
  width: _react2.default.PropTypes.number,
  min: _react2.default.PropTypes.number,
  max: _react2.default.PropTypes.number
};

exports.default = (0, _superficial2.default)(LookRule);