'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _superficial = require('superficial');

var _superficial2 = _interopRequireDefault(_superficial);

var _LookRule = require('./LookRule');

var _LookRule2 = _interopRequireDefault(_LookRule);

var _constants = require('../constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var LookSection = function (_React$Component) {
  _inherits(LookSection, _React$Component);

  function LookSection() {
    var _ref;

    _classCallCheck(this, LookSection);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    var _this = _possibleConstructorReturn(this, (_ref = LookSection.__proto__ || Object.getPrototypeOf(LookSection)).call.apply(_ref, [this].concat(args)));

    _this.onChange = _this.onChange.bind(_this);
    _this.addRule = _this.addRule.bind(_this);
    return _this;
  }

  _createClass(LookSection, [{
    key: 'onChange',
    value: function onChange(prop, value) {
      var _props = this.props,
          title = _props.title,
          rules = _props.rules,
          onChange = _props.onChange;

      if (value.to) {
        var newLooks = Object.assign({}, rules, _defineProperty({}, value.to, rules[prop]));
        delete newLooks[prop];
        onChange(title, newLooks);
      } else {
        onChange(title, Object.assign({}, rules, _defineProperty({}, prop, value)));
      }
    }
  }, {
    key: 'addRule',
    value: function addRule() {
      var _props2 = this.props,
          title = _props2.title,
          rules = _props2.rules,
          onChange = _props2.onChange;

      onChange(title, Object.assign({}, rules, { '| edit |': '| value |' }));
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props3 = this.props,
          rules = _props3.rules,
          title = _props3.title,
          min = _props3.min,
          max = _props3.max,
          width = _props3.width;

      var expanded = (0, _superficial.expandLookRules)(rules);
      return _react2.default.createElement(
        'tbody',
        { looks: this.looks.label },
        _react2.default.createElement(
          'tr',
          null,
          _react2.default.createElement(
            'td',
            { looks: this.looks.title },
            title
          )
        ),
        Object.keys(expanded).sort().map(function (prop) {
          return _react2.default.createElement(_LookRule2.default, _extends({
            key: prop,
            onChange: _this2.onChange,
            value: expanded[prop]
          }, { prop: prop, min: min, max: max, width: width }));
        }),
        _react2.default.createElement(
          'tr',
          null,
          _react2.default.createElement(
            'td',
            { looks: this.looks.addRule },
            _react2.default.createElement(
              'button',
              { looks: _constants.BUTTON_LOOK, onClick: this.addRule },
              '+ Add Rule'
            )
          )
        )
      );
    }
  }]);

  return LookSection;
}(_react2.default.Component);

LookSection.propTypes = {
  rules: _react2.default.PropTypes.object.isRequired,
  onChange: _react2.default.PropTypes.func.isRequired,
  title: _react2.default.PropTypes.string,
  width: _react2.default.PropTypes.number,
  min: _react2.default.PropTypes.number,
  max: _react2.default.PropTypes.number
};

LookSection.looks = {
  title: { textDecoration: 'underline' },
  addRule: { color: '#999', cursor: 'pointer' },
  label: {
    textTransform: 'uppercase',
    fontSize: '10px',
    color: '#444',
    fontFamily: 'Arial',
    fontWeight: '600',
    borderBottom: '10px solid transparent'
  }
};

exports.default = (0, _superficial2.default)(LookSection);