'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _superficial = require('superficial');

var _superficial2 = _interopRequireDefault(_superficial);

var _StyledRangeSlider = require('./StyledRangeSlider');

var _StyledRangeSlider2 = _interopRequireDefault(_StyledRangeSlider);

var _LookSection = require('./LookSection');

var _LookSection2 = _interopRequireDefault(_LookSection);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function LookTable(props, looks) {
  var min = props.min,
      max = props.max,
      width = props.width,
      onResize = props.onResize,
      onReset = props.onReset,
      onLookChange = props.onLookChange,
      rules = props.rules,
      override = props.override;

  return _react2.default.createElement(
    'div',
    { looks: looks.container },
    _react2.default.createElement(
      'table',
      { looks: looks.table },
      _react2.default.createElement(
        'tbody',
        null,
        _react2.default.createElement(
          'tr',
          null,
          _react2.default.createElement(
            'td',
            { looks: looks.leftCol },
            'WIDTH'
          ),
          _react2.default.createElement(
            'td',
            { looks: looks.rightCol },
            _react2.default.createElement(_StyledRangeSlider2.default, _extends({
              onChange: onResize,
              value: width
            }, { min: min, max: max }))
          )
        ),
        _react2.default.createElement(
          'tr',
          null,
          _react2.default.createElement('td', null),
          _react2.default.createElement(
            'td',
            { looks: looks.reset },
            override && _react2.default.createElement(
              'button',
              { looks: looks.reset, onClick: onReset },
              'Reset'
            )
          )
        )
      ),
      Object.keys(rules).map(function (title) {
        return _react2.default.createElement(_LookSection2.default, _extends({
          key: title,
          rules: rules[title],
          onChange: onLookChange
        }, { title: title, min: min, max: max, width: width }));
      })
    )
  );
}

LookTable.looks = {
  container: { margin: 10, width: '100%' },
  table: { width: '100%', borderCollapse: 'collapse' },
  rightCol: { width: '80%' },
  leftCol: {
    width: '20%',
    fontFamily: 'Arial',
    fontWeight: '600',
    fontSize: '13px'
  },
  reset: {
    textTransform: 'uppercase',
    fontSize: '10px',
    color: '#999',
    fontFamily: 'Arial',
    fontWeight: '600',
    height: '13px',
    cursor: 'pointer',
    width: '100%',
    textAlign: 'left',
    background: 'none',
    border: 0,
    padding: 0
  }
};

LookTable.propTypes = {
  rules: _react2.default.PropTypes.object.isRequired,
  onResize: _react2.default.PropTypes.func.isRequired,
  onReset: _react2.default.PropTypes.func.isRequired,
  onLookChange: _react2.default.PropTypes.func.isRequired,
  override: _react2.default.PropTypes.object,
  width: _react2.default.PropTypes.number,
  min: _react2.default.PropTypes.number,
  max: _react2.default.PropTypes.number
};

exports.default = (0, _superficial2.default)(LookTable);