'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _storybookAddons = require('@kadira/storybook-addons');

var _storybookAddons2 = _interopRequireDefault(_storybookAddons);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _constants = require('../constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Looks = function (_React$Component) {
  _inherits(Looks, _React$Component);

  function Looks() {
    var _ref;

    _classCallCheck(this, Looks);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    var _this = _possibleConstructorReturn(this, (_ref = Looks.__proto__ || Object.getPrototypeOf(Looks)).call.apply(_ref, [this].concat(args)));

    _this.handleOverride = _this.handleOverride.bind(_this);
    _this.state = {
      channel: _storybookAddons2.default.getChannel(),
      width: _this.props.width || _constants.DEFAULT_WIDTH
    };
    return _this;
  }

  _createClass(Looks, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.state.channel.on(_constants.OVERRIDE_EVENT, this.handleOverride);
      this.state.channel.emit(_constants.REGISTER_EVENT, this.getAttributes());
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      this.state.channel.emit(_constants.UPDATE_EVENT, this.getAttributes());
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.state.channel.removeListener(_constants.OVERRIDE_EVENT, this.handleOverride);
      this.state.channel.emit(_constants.UNREGISTER_EVENT);
    }
  }, {
    key: 'getAttributes',
    value: function getAttributes() {
      return {
        min: this.props.min || _constants.DEFAULT_MIN_WIDTH,
        max: this.props.max || _constants.DEFAULT_MAX_WIDTH,
        looks: this.props.children.type.looks,
        width: this.state.width
      };
    }
  }, {
    key: 'handleOverride',
    value: function handleOverride(override) {
      this.setState(override);
    }
  }, {
    key: 'render',
    value: function render() {
      var _state = this.state,
          width = _state.width,
          override = _state.override;

      return _react2.default.createElement(
        'div',
        null,
        _react2.default.cloneElement(this.props.children, { width: width, __looksOverride: override })
      );
    }
  }]);

  return Looks;
}(_react2.default.Component);

exports.default = Looks;


Looks.propTypes = {
  children: _react2.default.PropTypes.node.isRequired,
  min: _react2.default.PropTypes.number,
  max: _react2.default.PropTypes.number,
  width: _react2.default.PropTypes.number
};