'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _LookTable = require('./LookTable');

var _LookTable2 = _interopRequireDefault(_LookTable);

var _constants = require('../constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var LooksPanel = function (_React$Component) {
  _inherits(LooksPanel, _React$Component);

  function LooksPanel() {
    var _ref;

    _classCallCheck(this, LooksPanel);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    var _this = _possibleConstructorReturn(this, (_ref = LooksPanel.__proto__ || Object.getPrototypeOf(LooksPanel)).call.apply(_ref, [this].concat(args)));

    _this.onLookChange = _this.onLookChange.bind(_this);
    _this.onResize = _this.onResize.bind(_this);
    _this.onReset = _this.onReset.bind(_this);

    _this.props.channel.on(_constants.REGISTER_EVENT, function (opts) {
      return _this.setState(Object.assign({ active: true, override: null }, opts));
    });
    _this.props.channel.on(_constants.UPDATE_EVENT, function (opts) {
      return _this.setState(opts);
    });
    _this.props.channel.on(_constants.UNREGISTER_EVENT, function () {
      return _this.setState({ active: false });
    });

    _this.state = {};
    return _this;
  }

  _createClass(LooksPanel, [{
    key: 'onResize',
    value: function onResize(_ref2) {
      var value = _ref2.target.value;

      this.update({ width: parseInt(value, 10) });
    }
  }, {
    key: 'onLookChange',
    value: function onLookChange(section, rules) {
      this.update({
        override: Object.assign({}, this.state.override, _defineProperty({}, section, rules))
      });
    }
  }, {
    key: 'onReset',
    value: function onReset() {
      this.update({ override: null });
    }
  }, {
    key: 'update',
    value: function update(args) {
      this.props.channel.emit(_constants.OVERRIDE_EVENT, args);
      this.setState(args);
    }
  }, {
    key: 'render',
    value: function render() {
      if (!this.state.active) return null;
      var onLookChange = this.onLookChange,
          onResize = this.onResize,
          onReset = this.onReset;
      var _state = this.state,
          override = _state.override,
          width = _state.width,
          min = _state.min,
          max = _state.max,
          looks = _state.looks;

      var rules = Object.assign({}, looks, override);
      return _react2.default.createElement(_LookTable2.default, { rules: rules, onLookChange: onLookChange, onResize: onResize, onReset: onReset, min: min, max: max, width: width, override: override });
    }
  }]);

  return LooksPanel;
}(_react2.default.Component);

LooksPanel.propTypes = {
  channel: _react2.default.PropTypes.shape({
    emit: _react2.default.PropTypes.func,
    on: _react2.default.PropTypes.func
  }).isRequired
};

exports.default = LooksPanel;