'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _superficial = require('superficial');

var _superficial2 = _interopRequireDefault(_superficial);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var editableValue = function editableValue(value) {
  return (typeof value === 'undefined' ? 'undefined' : _typeof(value)) !== 'object' ? value : JSON.stringify(value).replace(/"([^"]+)":/g, '$1: ').replace(',', ', ').replace(/[{}]/g, '');
};

var parseInput = function parseInput(value) {
  return value.indexOf(':') === -1 ? value.replace(/-([a-z])/g, function (g) {
    return g[1].toUpperCase();
  }) : JSON.parse('{' + value.replace(/(\d+):/g, '"$1":') + '}');
};

function StyledInput(_ref, looks) {
  var defaultValue = _ref.defaultValue,
      onChange = _ref.onChange;

  var val = editableValue(defaultValue);
  var handleBlur = function handleBlur(_ref2) {
    var target = _ref2.target;

    var input = parseInput(target.value);
    onChange(input, val !== target.value);
  };
  return _react2.default.createElement('input', {
    looks: looks.input,
    style: {
      padding: (typeof defaultValue === 'undefined' ? 'undefined' : _typeof(defaultValue)) === 'object' ? '0 0 13px 0' : 0
    },
    defaultValue: editableValue(defaultValue),
    onFocus: function onFocus(e) {
      return e.target.select();
    },
    onBlur: handleBlur,
    autoFocus: true
  });
}

StyledInput.looks = {
  input: {
    fontSize: '10px',
    height: '11px',
    background: '#ddd',
    width: '100%',
    margin: 0,
    border: 0,
    outline: 0
  }
};

StyledInput.propTypes = {
  onChange: _react2.default.PropTypes.func.isRequired,
  defaultValue: _react2.default.PropTypes.any
};

exports.default = (0, _superficial2.default)(StyledInput);