'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _superficial = require('superficial');

var _superficial2 = _interopRequireDefault(_superficial);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var BUTTON_WIDTH = 30;
var STYLE_TAG = '\n  #superficial-slider {\n    width: 100%;\n    height: ' + BUTTON_WIDTH + 'px;\n    overflow: hidden;\n    cursor: pointer;\n    outline: none;\n  }\n  #superficial-slider,\n  #superficial-slider::-webkit-slider-runnable-track,\n  #superficial-slider::-webkit-slider-thumb {\n    -webkit-appearance: none;\n  }\n  #superficial-slider::-webkit-slider-runnable-track {\n    height: 4px;\n    background: #ccc;\n  }\n  #superficial-slider::-webkit-slider-thumb {\n    position: relative;\n    height: 15px;\n    width: ' + BUTTON_WIDTH + 'px;\n    margin-top: -5px;\n    border-radius: 6px;\n    z-index: 1;\n  }\n';

function StyledRangeSlider(props, looks) {
  // The real slider doesn't overflow the rail,
  // so we need to compute a manual offset to correct for this drift
  var leftPct = (props.value - props.min) / (props.max - props.min) * 100;
  var leftOffset = BUTTON_WIDTH / 2 - leftPct / 100 * BUTTON_WIDTH;
  var left = 'calc(' + leftPct + '% + ' + leftOffset + 'px)';
  var inputArgs = Object.assign({ id: 'superficial-slider', type: 'range' }, props);
  return _react2.default.createElement(
    'div',
    { looks: looks.container },
    _react2.default.createElement(
      'style',
      null,
      STYLE_TAG
    ),
    _react2.default.createElement('input', inputArgs),
    _react2.default.createElement(
      'div',
      { looks: looks.button, style: { left: left } },
      props.value
    )
  );
}

StyledRangeSlider.looks = {
  container: { position: 'relative' },
  button: {
    position: 'absolute',
    top: 9,
    fontSize: 10,
    width: BUTTON_WIDTH,
    height: 15,
    background: '#999',
    color: '#fff',
    marginLeft: -(BUTTON_WIDTH / 2),
    lineHeight: '15px',
    fontFamily: 'Arial',
    fontWeight: '600',
    border: '1px solid #fff',
    textAlign: 'center',
    borderRadius: BUTTON_WIDTH
  }
};

var numOrString = _react2.default.PropTypes.oneOfType([_react2.default.PropTypes.string, _react2.default.PropTypes.number]).isRequired;
StyledRangeSlider.propTypes = {
  value: numOrString,
  min: numOrString,
  max: numOrString
};

exports.default = (0, _superficial2.default)(StyledRangeSlider);